## Preparation

Preparation steps should ideally be completed within one day

- [ ] Temporarily disable the scheduled auto-deploy tasks via ChatOps:
   ```sh
   # In Slack
   /chatops run auto_deploy pause
   ```
- [ ] Disable Omnibus nightly builds by setting the schedules to inactive: https://dev.gitlab.org/gitlab/omnibus-gitlab/pipeline_schedules.
- [ ] Ensure that staging, canary, and production are all running the same version from the same auto-deploy branch
- [ ] Ensure latest auto-deploy branches are synced across Canonical, Security, and Build:
   ```sh
   # In Slack
   /chatops run mirror status
   ```

<% if critical? -%>
- [ ] Merge critical security merge requests using the UI.
  - Enable "Squash commits" option when merging.

- [ ] Cherry-pick the security fixes into the auto-deploy branch that is running on production.
<% else -%>
- [ ] Merge security merge requests using ChatOps

   ```sh
   # In Slack:
   /chatops run release merge --security
   ```

- [ ] If any merge requests could not be merged, investigate what needs to be done to resolve the issues. Do **not** proceed unless it has been determined safe to do so.

- Ensure security fixes are included in the auto-deploy branch. Fixes are automatically cherry-picked into the auto-deploy branch after they're merged. If they were not chery-picked, you can use the [cherry pick](https://gitlab.com/gitlab-org/release/docs/-/blob/master/general/security/utilities/cherry_pick_script.md) script to do it manually.
  - [ ] For GitLab
  - [ ] For Omnibus GitLab
<% end -%>

## Auto Deploy tag and deployment to GitLab.com

- [ ] Tag a new auto-deploy version via ChatOps (no need to wait for green build), to create a deployer pipeline that will deploy to Canary:
   ```sh
   # In Slack
   /chatops run auto_deploy tag --security
   ```

- [ ] Ping the Security Engineers so they can get started with the blog post. The blog post should be done on `https://dev.gitlab.org/gitlab/www-gitlab-com`

- [ ] Once the deployment to Canary has been completed, if there are no issues reported on Sentry and no active production incidents, proceed to promote to production.

## Packaging

- [ ] Ensure tests are green in CE and green in EE
   ```sh
   # In Slack:
   /chatops run release status --security
   ```

<% versions.each do |version| -%>
- [ ] Tag the <%= version.to_patch %> security release, and wait for the pipeline to finish: `/chatops run release tag --security <%= version.to_patch %>`
<% end %>

Waiting between pipelines is necessary as they may othewrise fail to
concurrently push changes to the same project/branch.

- [ ] Check that EE and CE packages are built:
  <% versions.each do |version| -%>
  - <%= version.to_patch %>: [EE packages](https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.to_omnibus(ee: true) %>) and [CE packages](https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.to_omnibus %>)
  <% end %>

## Deploy

- [ ] Verify that release.gitlab.net is running the latest patch version
  - Check in Slack `#announcements` channel
  - Go to https://release.gitlab.net/help

## Release

- [ ] This section should be done in coordination with the Security team, so **make sure to confirm with them before proceeding**
  ```sh
  # In Slack
  @appsec-team - We are ready to publish the security release packages for <%= version %>, please let us know if the blog post is ready.
  ```

- [ ] Publish the packages via ChatOps:

  ```sh
   # In Slack:
  <% versions.each do |version| -%>
  /chatops run publish <%= version %>
  <% end %>
  ```
- [ ] Verify that EE packages appear on `packages.gitlab.com`: [EE](https://packages.gitlab.com/app/gitlab/gitlab-ee/search?q=<%= version %>) (should contain 14 packages)
- [ ] Verify that CE packages appear on `packages.gitlab.com`: [CE](https://packages.gitlab.com/app/gitlab/gitlab-ce/search?q=<%= version %>) (should contain 13 packages)
- [ ] Verify that Docker images appear on `hub.docker.com`: [EE](https://hub.docker.com/r/gitlab/gitlab-ee/tags) / [CE](https://hub.docker.com/r/gitlab/gitlab-ce/tags)
- [ ] Create the versions:
  <% versions.each do |version| -%>
  - `<%= version %>` version on [version.gitlab.com](https://version.gitlab.com/versions/new?version=<%= version %>). **Be sure to mark it as a security release.**
  <% end %>

- [ ] Merge the blog post on `https://gitlab.com/gitlab-com/www-gitlab-com`
- [ ] In the `#content-updates` channel, share a link to the blog post.

### Sync

- [ ] Sync `master` and `auto-deploy` branches for GitLab, GitLab Foss, Omnibus GitLab and Gitaly, via ChatOps:
   ```sh
   # In Slack
   /chatops run release sync_remotes --security
   ```

- [ ] Verify all remotes are synced:

   ```sh
   # In Slack
   /chatops run mirror status
   ```

   If conflicts are found, manual intervention will be needed to sync the repositories.

### Auto-Deploy

- [ ] Re-enable the scheduled auto-deploy tasks via ChatOps:
   ```sh
   # In Slack
   /chatops run auto_deploy unpause
   ```
- [ ] Enable Omnibus nightly builds by setting the schedules to active https://dev.gitlab.org/gitlab/omnibus-gitlab/pipeline_schedules
